<?xml version="1.0"?>
<!--
** Module   : hibernate_templates.tpl
** Abstract : Hibernate AST templates used during mapping document generation
**
** Copyright (c) 2005-2013, Golden Code Development Corporation.
** ALL RIGHTS RESERVED. Use is subject to license terms.
**
**           Golden Code Development Corporation
**                      CONFIDENTIAL
**
** _#_ _I_ __Date__ __JPRM__ ____________________________Description_____________________________
** 001 ECF 20050804   @22006 Good working version. Includes templates for
**                           the DTD and root document elements, primary
**                           key, simple and composite lists, one-to-one
**                           and many-to-one associations.
** 002 ECF 20050830   @22413 Added templates to support creation of DMO
**                           index. This document lists all DMO class
**                           names managed by Hibernate, organized by
**                           database.
** 003 ECF 20050908   @22643 Added support for raw wrapper data type.
**                           Added a typedef for RawUserType.
** 004 ECF 20050929   @22957 Account for refactored DMOs. Interface and
**                           implementation classes are split.
** 005 ECF 20051027   @23207 Added templates for unique constraint and
**                           case-sensitive elements. The latter currently
**                           is unused.
** 006 ECF 20060112   @23940 Modified dmo_index_dtd_node. Made SYSTEM_ID
**                           relative to current directory.
** 007 ECF 20060201   @24337 Added temp table support. Modified and added
**                           templates related to dmo_index.xml creation.
** 008 ECF 20060309   @25039 Added support for foreign relation joins.
**                           Added dmo_index_foreign_elem template.
** 009 ECF 20060807   @28465 Implemented second-level cache. Use a default
**                           strategy of nonstrict-read-write for all top
**                           level DMOs and for all extext-field list
**                           associations.
** 010 ECF 20070924   @35214 Removed typedef for LongCharacterUserType.
**                           This user type is now obsolete; instead we
**                           use CharacterUserType. Also changed primary
**                           key ID generator class from 'native' to
**                           'assigned', since we do not allow Hibernate
**                           to assign primary key IDs.
** 011 ECF 20080302   @37522 Enabled computed columns. Also added cascaded
**                           eviction of extent field associations.
** 012 ECF 20080806   @39330 Added rowid support. Account for new package
**                           of *UserType classes in mapping typedefs.
** 013 OM  20130107          Added support for sequence definitions.
** 014 GES 20130121          Added int64, datetime and datetime-tz.  
** 015 SVL 20130331          Hibernate namespace changed to hibernate.org.
** 016 OM  20130524          Added two_column_property_def template for datetime-tz.
-->

<templates>

  <!-- Hibernate mapping document DTD node -->
  <ast-root name="hbm_dtd_node" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="DOCUMENT_TYPE_NODE" text="hibernate-mapping">
      <ast id="0" type="PUBLIC_ID" text="-//Hibernate/Hibernate Mapping DTD 3.0//EN" />
      <ast id="0" type="SYSTEM_ID" text="http://www.hibernate.org/dtd/hibernate-mapping-3.0.dtd" />
    </ast>
  </ast-root>
  
  <!-- DMO index document DTD node -->
  <ast-root name="dmo_index_dtd_node" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="DOCUMENT_TYPE_NODE" text="dmo-index">
      <ast id="0" type="SYSTEM_ID" text="dmo-index-1.0.dtd" />
    </ast>
  </ast-root>
  
  <!-- DMO index document root element -->
  <ast-root name="dmo_index_root" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="dmo-index">
      <ast id="0" type="ATTR_SET" text="">
        <ast id="0" type="ATTRIBUTE_NODE" text="package">
          <ast id="0" type="CONTENT" text="${package}" />
        </ast>
      </ast>
    </ast>
  </ast-root>
  
  <!-- DMO index document database element -->
  <ast-root name="dmo_index_schema_elem" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="schema">
      <ast id="0" type="ATTR_SET" text="">
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${name}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="impl">
          <ast id="0" type="CONTENT" text="${name}.impl" />
        </ast>
      </ast>
    </ast>
  </ast-root>

  <!-- DMO index document sequence element -->
  <ast-root name="dmo_index_sequence_elem" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
   <ast id="0" type="ELEMENT_NODE" text="sequence">
      <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
      <ast id="0" type="ATTR_SET" text="">
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${name}" />
        </ast>
      </ast>
   </ast>
  </ast-root>

  <!-- DMO index document class element -->
  <ast-root name="dmo_index_class_elem" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="class">
      <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
      <ast id="0" type="ATTR_SET" text="">
        <ast id="0" type="ATTRIBUTE_NODE" text="interface">
          <ast id="0" type="CONTENT" text="${name}" />
        </ast>
        <!--
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${name}Impl" />
        </ast>
        -->
      </ast>
    </ast>
  </ast-root>
  
  <!-- DMO index document foreign element -->
  <ast-root name="dmo_index_foreign_elem" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="foreign">
      <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
      <ast id="0" type="ATTR_SET" text="">
        <ast id="0" type="ATTRIBUTE_NODE" text="interface">
          <ast id="0" type="CONTENT" text="${name}" />
        </ast>
        <!--
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${name}Impl" />
        </ast>
        -->
      </ast>
    </ast>
  </ast-root>
  
  <!-- DMO index document named property element -->
  <ast-root name="dmo_index_named_prop_elem" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="${element}">
      <ast id="0" type="ATTR_SET" text="">
        <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${name}" />
        </ast>
      </ast>
    </ast>
  </ast-root>
  
  <!-- attribute set stub with a "name" attribute -->
  <ast-root name="attr_set_stub" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ATTR_SET" text="">
      <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
      <ast id="0" type="ATTRIBUTE_NODE" text="name">
        <ast id="0" type="CONTENT" text="${name}" />
      </ast>
    </ast>
  </ast-root>
  
  <!-- attribute content -->
  <ast-root name="attr_content" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ATTRIBUTE_NODE" text="${name}">
      <ast id="0" type="CONTENT" text="${content}" />
    </ast>
  </ast-root>
  
  <!-- hibernate-mapping element; peernode is class -->
  <!-- defines typedefs, class, and primary key comment -->
  <ast-root name="mapping_def" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="hibernate-mapping">
      <ast id="0" type="ATTR_SET" text="">
        <ast id="0" type="ATTRIBUTE_NODE" text="package">
          <ast id="0" type="CONTENT" text="${package}" />
        </ast>
      </ast>
      <ast id="0" type="COMMENT_NODE" text="#comment">
        <ast id="0" type="CONTENT" text=" Typedefs for P2J wrapper types " />
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="typedef">
        <ast id="0" type="ATTR_SET" text="">
          <ast id="0" type="ATTRIBUTE_NODE" text="class">
            <ast id="0" type="CONTENT" text="com.goldencode.p2j.persist.type.IntegerUserType" />
          </ast>
          <ast id="0" type="ATTRIBUTE_NODE" text="name">
            <ast id="0" type="CONTENT" text="p2j_integer" />
          </ast>
        </ast>
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="typedef">
        <ast id="0" type="ATTR_SET" text="">
          <ast id="0" type="ATTRIBUTE_NODE" text="class">
            <ast id="0" type="CONTENT" text="com.goldencode.p2j.persist.type.Int64UserType" />
          </ast>
          <ast id="0" type="ATTRIBUTE_NODE" text="name">
            <ast id="0" type="CONTENT" text="p2j_int64" />
          </ast>
        </ast>
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="typedef">
        <ast id="0" type="ATTR_SET" text="">
          <ast id="0" type="ATTRIBUTE_NODE" text="class">
            <ast id="0" type="CONTENT" text="com.goldencode.p2j.persist.type.DecimalUserType" />
          </ast>
          <ast id="0" type="ATTRIBUTE_NODE" text="name">
            <ast id="0" type="CONTENT" text="p2j_decimal" />
          </ast>
        </ast>
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="typedef">
        <ast id="0" type="ATTR_SET" text="">
          <ast id="0" type="ATTRIBUTE_NODE" text="class">
            <ast id="0" type="CONTENT" text="com.goldencode.p2j.persist.type.LogicalUserType" />
          </ast>
          <ast id="0" type="ATTRIBUTE_NODE" text="name">
            <ast id="0" type="CONTENT" text="p2j_logical" />
          </ast>
        </ast>
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="typedef">
        <ast id="0" type="ATTR_SET" text="">
          <ast id="0" type="ATTRIBUTE_NODE" text="class">
            <ast id="0" type="CONTENT" text="com.goldencode.p2j.persist.type.CharacterUserType" />
          </ast>
          <ast id="0" type="ATTRIBUTE_NODE" text="name">
            <ast id="0" type="CONTENT" text="p2j_character" />
          </ast>
        </ast>
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="typedef">
        <ast id="0" type="ATTR_SET" text="">
          <ast id="0" type="ATTRIBUTE_NODE" text="class">
            <ast id="0" type="CONTENT" text="com.goldencode.p2j.persist.type.DateUserType" />
          </ast>
          <ast id="0" type="ATTRIBUTE_NODE" text="name">
            <ast id="0" type="CONTENT" text="p2j_date" />
          </ast>
        </ast>
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="typedef">
        <ast id="0" type="ATTR_SET" text="">
          <ast id="0" type="ATTRIBUTE_NODE" text="class">
            <ast id="0" type="CONTENT" text="com.goldencode.p2j.persist.type.DatetimeUserType" />
          </ast>
          <ast id="0" type="ATTRIBUTE_NODE" text="name">
            <ast id="0" type="CONTENT" text="p2j_datetime" />
          </ast>
        </ast>
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="typedef">
        <ast id="0" type="ATTR_SET" text="">
          <ast id="0" type="ATTRIBUTE_NODE" text="class">
            <ast id="0" type="CONTENT" text="com.goldencode.p2j.persist.type.DatetimeTzUserType" />
          </ast>
          <ast id="0" type="ATTRIBUTE_NODE" text="name">
            <ast id="0" type="CONTENT" text="p2j_datetimetz" />
          </ast>
        </ast>
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="typedef">
        <ast id="0" type="ATTR_SET" text="">
          <ast id="0" type="ATTRIBUTE_NODE" text="class">
            <ast id="0" type="CONTENT" text="com.goldencode.p2j.persist.type.RawUserType" />
          </ast>
          <ast id="0" type="ATTRIBUTE_NODE" text="name">
            <ast id="0" type="CONTENT" text="p2j_raw" />
          </ast>
        </ast>
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="typedef">
        <ast id="0" type="ATTR_SET" text="">
          <ast id="0" type="ATTRIBUTE_NODE" text="class">
            <ast id="0" type="CONTENT" text="com.goldencode.p2j.persist.type.RowIDUserType" />
          </ast>
          <ast id="0" type="ATTRIBUTE_NODE" text="name">
            <ast id="0" type="CONTENT" text="p2j_rowid" />
          </ast>
        </ast>
      </ast>
      <ast id="0" type="COMMENT_NODE" text="#comment">
        <ast id="0" type="CONTENT" text=" ${classdesc} " />
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="class">
        <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
        <ast id="0" type="ATTR_SET" text="">
          <ast id="0" type="ATTRIBUTE_NODE" text="name">
            <ast id="0" type="CONTENT" text="${classname}" />
          </ast>
          <ast id="0" type="ATTRIBUTE_NODE" text="table">
            <ast id="0" type="CONTENT" text="${tablename}" />
          </ast>
        </ast>
        <ast id="0" type="COMMENT_NODE" text="#comment">
          <ast id="0" type="CONTENT" text=" Second level cache " />
        </ast>
        <ast id="0" type="ELEMENT_NODE" text="cache">
          <ast id="0" type="ATTR_SET" text="">
            <ast id="0" type="ATTRIBUTE_NODE" text="usage">
              <ast id="0" type="CONTENT" text="nonstrict-read-write" />
            </ast>
          </ast>
        </ast>
        <ast id="0" type="COMMENT_NODE" text="#comment">
          <ast id="0" type="CONTENT" text=" Surrogate primary key " />
        </ast>
      </ast>
    </ast>
  </ast-root>
  
  <!-- Surrogate primary key definition, using native generator -->
  <ast-root name="pkey_def" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="id">
      <ast id="0" type="ATTR_SET" text="">
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${name}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="type">
          <ast id="0" type="CONTENT" text="${type}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="column">
          <ast id="0" type="CONTENT" text="${column}" />
        </ast>
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="generator">
        <ast id="0" type="ATTR_SET" text="">
          <ast id="0" type="ATTRIBUTE_NODE" text="class">
            <ast id="0" type="CONTENT" text="assigned" />
          </ast>
        </ast>
      </ast>
    </ast>
  </ast-root>
  
  <!-- two column property element definition; peernode is property attr-set -->
  <ast-root name="two_column_property_def" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="property">
      <ast id="0" type="ATTR_SET" text="">
        <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${name}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="type">
          <ast id="0" type="CONTENT" text="${type}" />
        </ast>
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="column">
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${column_1}" />
        </ast>
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="column">
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${column_2}" />
        </ast>
      </ast>
    </ast>
  </ast-root>
  
    <!-- property element definition; peernode is property attr-set -->
  <ast-root name="property_def" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="property">
      <ast id="0" type="ATTR_SET" text="">
        <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${name}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="column">
          <ast id="0" type="CONTENT" text="${column}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="type">
          <ast id="0" type="CONTENT" text="${type}" />
        </ast>
      </ast>
    </ast>
  </ast-root>
  
  <!-- list definition; peernode is list element -->
  <ast-root name="list_def" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="list">
      <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
      <ast id="0" type="ATTR_SET" text="">
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${name}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="table">
          <ast id="0" type="CONTENT" text="${table}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="lazy">
          <ast id="0" type="CONTENT" text="true" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="cascade">
          <ast id="0" type="CONTENT" text="evict" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="access">
          <ast id="0" type="CONTENT" text="${access}" />
        </ast>
      </ast>
      <ast id="0" type="COMMENT_NODE" text="#comment">
        <ast id="0" type="CONTENT" text=" Second level cache " />
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="cache">
        <ast id="0" type="ATTR_SET" text="">
          <ast id="0" type="ATTRIBUTE_NODE" text="usage">
            <ast id="0" type="CONTENT" text="${cache}" />
          </ast>
        </ast>
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="key">
        <ast id="0" type="ELEMENT_NODE" text="column">
          <ast id="0" type="ATTR_SET" text="">
            <ast id="0" type="ATTRIBUTE_NODE" text="name">
              <ast id="0" type="CONTENT" text="parent__id" />
            </ast>
            <ast id="0" type="ATTRIBUTE_NODE" text="index">
              <ast id="0" type="CONTENT" text="${table}_fkey" />
            </ast>
          </ast>
        </ast>
      </ast>
      <ast id="0" type="ELEMENT_NODE" text="index">
        <ast id="0" type="ATTR_SET" text="">
          <ast id="0" type="ATTRIBUTE_NODE" text="column">
            <ast id="0" type="CONTENT" text="list__index" />
          </ast>
        </ast>
      </ast>
    </ast>
  </ast-root>
  
  <!-- composite-element definition; peernode is composite-element -->
  <ast-root name="composite_element_def" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="composite-element">
      <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
      <ast id="0" type="ATTR_SET" text="">
        <ast id="0" type="ATTRIBUTE_NODE" text="class">
          <ast id="0" type="CONTENT" text="${class}" />
        </ast>
      </ast>
    </ast>
  </ast-root>
  
  <!-- element definition; peernode is "element" element attrset -->
  <ast-root name="element_def" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="element">
      <ast id="0" type="ATTR_SET" text="">
        <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
        <ast id="0" type="ATTRIBUTE_NODE" text="column">
          <ast id="0" type="CONTENT" text="${column}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="type">
          <ast id="0" type="CONTENT" text="${type}" />
        </ast>
      </ast>
    </ast>
  </ast-root>
  
  <!-- one-to-one table association -->
  <ast-root name="one_to_one_def" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="one-to-one">
      <ast id="0" type="ATTR_SET" text="">
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${name}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="class">
          <ast id="0" type="CONTENT" text="${class}Impl" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="property-ref">
          <ast id="0" type="CONTENT" text="${property}" />
        </ast>
      </ast>
    </ast>
  </ast-root>
  
  <!-- many-to-one table association -->
  <ast-root name="many_to_one_def" terse="true" ast_class="com.goldencode.p2j.xml.XmlAst" >
    <ast id="0" type="ELEMENT_NODE" text="many-to-one">
      <ast id="0" type="ATTR_SET" text="">
        <annotation datatype="java.lang.Boolean" key="peernode" value="true" />
        <ast id="0" type="ATTRIBUTE_NODE" text="name">
          <ast id="0" type="CONTENT" text="${name}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="class">
          <ast id="0" type="CONTENT" text="${class}" />
        </ast>
        <ast id="0" type="ATTRIBUTE_NODE" text="column">
          <ast id="0" type="CONTENT" text="${column}" />
        </ast>
      </ast>
    </ast>
  </ast-root>
  
</templates>
